/* Agent Tcl
   Bob Gray
   10 January 1996

   tclConversion.h

   This file defines various conversion routines.

   Copyright (c) 1995-1996, Bob Gray, Dartmouth College

   See the file "agent.terms" for information on usage and redistribution
   of this file and for a DISCLAIMER OF ALL WARRANTIES.
*/

#ifndef _TCL_CONVERSION_H
#define _TCL_CONVERSION_H

#ifndef NO_PRAGMAS
#pragma interface
#endif

#ifdef __cplusplus
#define EXTERNAL extern "C"
#else
#define EXTERNAL extern
#endif

struct AgentId;
struct AgentMaskEntry;
struct Tcl_DString;
struct Tcl_Interp;
struct Tcl_Obj;

EXTERNAL AgentId *Agent_SplitAgentId
	(Tcl_Interp *interp, char *string);

#ifdef TCL8  

EXTERNAL AgentId *Agent_SplitAgentIdObj
	(Tcl_Interp *interp, Tcl_Obj *idListObj);

#endif

EXTERNAL struct AgentMaskEntry *Agent_SplitAgentMaskEntry  
	(Tcl_Interp *interp, char *string);

#endif
